/**
 * Created by The eXo Platform SARL
 * Author : Alexey Zavizionov
 *          alexey.zavizionov@exoplatform.com.ua
 */
package org.exoplatform.services.portletcontainer.test.portlet2;

import javax.portlet.*;
import javax.xml.namespace.QName;

import java.io.IOException;
import java.io.PrintWriter;

public class TestServeFragment extends GenericPortlet implements FragmentServingPortlet{

  
  protected void doView(RenderRequest renderRequest, RenderResponse renderResponse)
      throws PortletException, IOException {
    //System.out.println("In doView method of TestPortletNEW...");
    
    renderResponse.setContentType("text/html; charset=UTF-8");
    PrintWriter w = renderResponse.getWriter();
    w.println(((new Exception()).getStackTrace()[0]).getMethodName());
    w.println("<br>");
    
    FragmentURL fragmentURL = renderResponse.createFragmentURL();
    w.println("<p><a href=\"" + fragmentURL.toString() + "\">fragmentURL</a></p>");
    
    PortletContext context = getPortletContext();
    PortletRequestDispatcher rd = context.getRequestDispatcher("/WEB-INF/script.jsp");
    rd.include(renderRequest, renderResponse);

    w.println("----------------------------------------<br>");
  }    
    
  protected void doEdit(RenderRequest renderRequest, RenderResponse renderResponse)
      throws PortletException, IOException {
    //System.out.println("In doEdit method of TestPortletNEW...");
    renderResponse.setContentType("text/html; charset=UTF-8");
    PrintWriter w = renderResponse.getWriter();
    w.println(((new Exception()).getStackTrace()[0]).getMethodName());
  }

  protected void doHelp(RenderRequest renderRequest, RenderResponse renderResponse)
      throws PortletException, IOException {
    //System.out.println("In doHelp method of TestPortletNEW...");
    renderResponse.setContentType("text/html; charset=UTF-8");
    PrintWriter w = renderResponse.getWriter();
    w.println(((new Exception()).getStackTrace()[0]).getMethodName());
  }

  public void processAction(ActionRequest actionRequest, ActionResponse actionResponse)
      throws PortletException, IOException {
    //System.out.println("In processAction method of TestPortletNEW...");
  }

  public void render(RenderRequest renderRequest, RenderResponse renderResponse)
      throws PortletException, IOException {
    //System.out.println("In render method of TestPortletNEW...");
    super.render(renderRequest, renderResponse);
  }

  public void serveFragment(FragmentRequest request, FragmentResponse response) throws PortletException, IOException {
    //System.out.println("In render method of TestPortletNEW...");
    response.setContentType("text/html; charset=UTF-8");
    PrintWriter w = response.getWriter();
    w.println("MARKUP FROM SERVEFRAGMENT");
    
    MyEventPub sampleAddress = new MyEventPub();
    sampleAddress.setStreet("myStreet");
    sampleAddress.setCity("myCity");
    response.setEvent(new QName("MyEventPub2"), sampleAddress);
  }

}
