package javax.portlet;

import java.io.PrintStream;
import java.io.PrintWriter;

public class PortletException extends Exception {

  private Throwable cause;

  public PortletException() {
  }

  public PortletException(String text) {
    super(text);
  }

  public PortletException(String text, Throwable cause) {
    super(text);
    this.cause = cause;
  }

  public PortletException(Throwable cause) {
    this.cause = cause;
  }

  public void printStackTrace() {
    printStackTrace(System.err);
  }

  public void printStackTrace(PrintStream out) {
    printStackTrace(new PrintWriter(out, true));
  }

  public void printStackTrace(PrintWriter out) {
    super.printStackTrace(out);
    if (getCause() != null) {
      out.println();
      out.print("Nested Exception is ");
      getCause().printStackTrace(out);
    }
  }

  public Throwable getCause() {
    return cause == null ? null : cause;
  }
}
