package javax.portlet;

import java.util.Enumeration;

public interface PortletSession {

  public static final int APPLICATION_SCOPE = 1;
  public static final int PORTLET_SCOPE = 2;

  public abstract Object getAttribute(String name);

  public abstract Object getAttribute(String name, int scope);

  public abstract Enumeration getAttributeNames();

  public abstract Enumeration getAttributeNames(int scope);

  public abstract long getCreationTime();

  public abstract String getId();

  public abstract long getLastAccessedTime();

  public abstract int getMaxInactiveInterval();

  public abstract void invalidate();

  public abstract boolean isNew();

  public abstract void removeAttribute(String name);

  public abstract void removeAttribute(String name, int scope);

  public abstract void setAttribute(String name, Object obj);

  public abstract void setAttribute(String name, Object obj, int scope);

  public abstract void setMaxInactiveInterval(int i);

  public abstract PortletContext getPortletContext();
}
