package javax.portlet.filter;

import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.util.Enumeration;
import java.util.Locale;
import java.util.Map;

import javax.portlet.CacheControl;
import javax.portlet.FragmentRequest;
import javax.portlet.FragmentResponse;
import javax.portlet.FragmentURL;
import javax.portlet.PortletMode;
import javax.portlet.PortletModeException;
import javax.portlet.PortletURL;
import javax.portlet.ResourceURL;
import javax.portlet.WindowState;
import javax.portlet.WindowStateException;
import javax.servlet.http.Cookie;
import javax.xml.namespace.QName;


public class FragmentResponseWrapper implements FragmentResponse {

  FragmentResponse response;

  private FragmentResponseWrapper() {
  }

  public FragmentResponseWrapper(FragmentResponse response) {
    this.response = response;
  }

  public void addProperty(String key, String value) {
    response.addProperty(key, value);
  }

  public void addProperty(String key, String value, int scope) {
  response.addProperty(key, value, scope);
  }
  
  public PortletURL createActionURL() {
    return response.createActionURL();
  }

  public PortletURL createRenderURL() {
    return response.createRenderURL();
  }

  public ResourceURL createResourceURL() {
    return response.createResourceURL();
  }
  
  public ResourceURL createResourceURL(boolean markupContainsPortletURLs) {
    return response.createResourceURL(markupContainsPortletURLs);
  }

  public String encodeURL(String path) {
    return response.encodeURL(path);
  }

  public String getNamespace() {
    return response.getNamespace();
  }

  public void setProperty(String key, String value) {
    response.setProperty(key, value);
  }

  public void setProperty(String key, String value, int scope) {
    response.setProperty(key, value, scope);
  }

  public void flushBuffer() throws IOException {
    response.flushBuffer();
  }

  public int getBufferSize() {
    return response.getBufferSize();
  }

  public String getCharacterEncoding() {
    return response.getCharacterEncoding();
  }

  public String getContentType() {
    return response.getContentType();
  }

  public Locale getLocale() {
    return response.getLocale();
  }

  public OutputStream getPortletOutputStream() throws IOException {
    return response.getPortletOutputStream();
  }

  public PrintWriter getWriter() throws IOException {
    return response.getWriter();
  }

  public boolean isCommitted() {
    return response.isCommitted();
  }

  public void reset() {
    response.reset();
  }

  public void resetBuffer() {
    response.resetBuffer();
  }

  public void setBufferSize(int size) {
    response.setBufferSize(size);
  }

  public void setContentType(String type) {
    response.setContentType(type);
  }

  public void setTitle(String title) {
    response.setTitle(title);
  }

  public CacheControl getCacheControl() {
    return response.getCacheControl();
  }

  public void setCharacterEncoding(String charset) {
    this.setCharacterEncoding(charset);
    return;
  }

  public void setLocale(Locale loc) {
    this.setLocale(loc);
    return;
  }

  public FragmentURL createFragmentURL() {
    return response.createFragmentURL();
  }

  public void setNextPossiblePortletModes(Enumeration portletModes) {
    response.setNextPossiblePortletModes(portletModes);
  }

  public void sendRedirect(String location) throws IOException {
    response.sendRedirect(location);
  }

  public void setEvent(QName name, Object value) {
    response.setEvent(name, value);
  }

  public void setEvents(Map events) {
    response.setEvents(events);
  }

  public void setPortletMode(PortletMode portletMode) throws PortletModeException {
    response.setPortletMode(portletMode);
  }

  public void setRenderParameter(String key, String value) {
    response.setRenderParameter(key, value);
  }

  public void setRenderParameter(String key, String[] values) {
    response.setRenderParameter(key, values);
  }

  public void setRenderParameters(Map parameters) {
    response.setRenderParameters(parameters);
  }

  public void setWindowState(WindowState windowState) throws WindowStateException {
    response.setWindowState(windowState);
  }

  public PortletMode getPortletMode() {
    return response.getPortletMode();
  }

  public Map getRenderParameterMap() {
    return response.getRenderParameterMap();
  }

  public WindowState getWindowState() {
    return response.getWindowState();
  }

  public void setRenderParameters(FragmentRequest request) {
    response.setRenderParameters(request);
  }

  public void addProperty(Cookie cookie) {
    response.addProperty(cookie);
  }

}
