package org.exoplatform.services.portletcontainer.plugins.pc.filter;


import org.exoplatform.services.portletcontainer.pci.model.Portlet;

import javax.portlet.ActionRequest;
import javax.portlet.ActionResponse;
import javax.portlet.EventRequest;
import javax.portlet.EventResponse;
import javax.portlet.PortletRequest;
import javax.portlet.PortletResponse;
import javax.portlet.PortletException;
import javax.portlet.RenderRequest;
import javax.portlet.RenderResponse;
import javax.portlet.ResourceRequest;
import javax.portlet.ResourceResponse;
import javax.portlet.filter.Filter;
import javax.portlet.filter.FilterChain;

import java.util.Collection;
import java.util.Iterator;
import java.io.IOException;


/**
 * Copyright 2001-2003 The eXo platform SARL All rights reserved.
 * Please look at license.txt in info directory for more license detail.
 **/

/**
 * Created by the Exo Development team.
 * Author : Mestrallet Benjamin
 *          benjmestrallet@users.sourceforge.net
 * Date: 17 nov. 2003
 * Time: 21:21:35
 */
public class PortletFilterChainImpl implements FilterChain {

  private Collection filters;
	private Iterator iterator;
	private Portlet portlet;
	private int isAction;

//  public PortletFilterChainImpl() {
//    // TODO Auto-generated constructor stub
//  }
  
	public PortletFilterChainImpl(Collection filters, Portlet p) {
	  this.filters = filters;
		this.portlet = p;
	}

	public Iterator getFiltersIterator() {
		return filters.iterator();
	}

	public void invoke(PortletRequest request, PortletResponse response, int isAction) throws IOException, PortletException {
		this.iterator = filters.iterator();
		this.isAction = isAction;
		if (iterator.hasNext()) {
      Filter portletFilter = (Filter) iterator.next();
      portletFilter.doFilter(request, response, this);
    }
	}

/*
	public void doFilter(PortletRequest request, PortletResponse response) throws IOException, PortletException {
		if(iterator.hasNext()){
			Filter portletFilter = (Filter) iterator.next();
			portletFilter.doFilter(request, response, this);
      // java.util.Collection,org.exoplatform.services.portletcontainer.pci.model.Portlet
		}
*/
      /* else {
      if (isAction == Constants.actionInt)
				portlet.processAction((ActionRequest)request, (ActionResponse)response);
      else
      if (isAction == Constants.eventInt)
				portlet.processEvent((EventRequest)request, (EventResponse)response);
      else
      if (isAction == Constants.resourceInt)
				portlet.serveResource((ResourceRequest)request, (ResourceResponse)response);
			else
				portlet.render((RenderRequest)request, (RenderResponse)response);
		}*/
/*
	}
*/

  public void doFilter(ActionRequest request, ActionResponse response) throws IOException, PortletException {
    if(iterator.hasNext()){
      Filter portletFilter = (Filter) iterator.next();
      portletFilter.doFilter(request, response, this);
    } else {
      //portlet.processAction((ActionRequest)request, (ActionResponse)response);
    }
  }
  
  public void doFilter(EventRequest request, EventResponse response) throws IOException, PortletException {
    if(iterator.hasNext()){
      Filter portletFilter = (Filter) iterator.next();
      portletFilter.doFilter(request, response, this);
    } else {
      //portlet.processEvent((EventRequest)request, (EventResponse)response);
    }
  }
  
  public void doFilter(RenderRequest request, RenderResponse response) throws IOException, PortletException {
    if(iterator.hasNext()){
      Filter portletFilter = (Filter) iterator.next();
      portletFilter.doFilter(request, response, this);
    } else {
      //portlet.render((RenderRequest)request, (RenderResponse)response);
    }
  }
  
  public void doFilter(ResourceRequest request, ResourceResponse response) throws IOException, PortletException {
    if(iterator.hasNext()){
      Filter portletFilter = (Filter) iterator.next();
      portletFilter.doFilter(request, response, this);
    } else {
      //portlet.serveResource((ResourceRequest)request, (ResourceResponse)response);
    }
  }

}
